#ifndef INSTANCEMANAGER_H_INCLUDED
#define INSTANCEMANAGER_H_INCLUDED

#include "stdafx.h"
#define MYSQLPP_SSQLS_NO_STATICS
#include "RenderingMax.h"

namespace CloudResourceManager
{
    class InstanceManager
    {
    private:
        MySqlppHelper mySqlppHelper;
        int RequestStatusName2Id(const string& name);
        int EC2InstanceStatusName2Id(const string& name);
        void CheckInstanceWorker(int instanceStatus);
        void CheckRequestWorker(int requestStatus);
        void Check_New_Request();
    public:
        void Check_Open_Request();
        void Check_Active_Request();
        void Check_New_Instance();
        void Check_Opened_Instance();
        void Check_Active_Instance();
        void Check_Initiate_Instance();
        bool CreateRegularRequest(int nTaskId, const string& AMIId, const string& strEC2InstanceType);
        bool CreateSpotRequest(int nTaskId, const string& AMIId, const string& ec2InstanceType);
        bool TerminateEC2Instance(const string& instanceId);
        void Check_Unused_Instance();
        bool CreateEC2InstanceRequestHelper(int iTaskId);
        void ScaleInstancesByTask(int taskId);
        void CheckInstanceRequestHelper(EC2_Requests& myEC2Request);
        void CheckNewInstanceHelper(EC2_Instances& myInstance);
        void CheckOpenInstanceHelper(EC2_Instances& myInstance);
        void CheckActiveInstanceHelper(EC2_Instances& myInstance);
        void CheckInitiateInstanceHelper(EC2_Instances& myInstance);
        void Check_BlackListUser();
        void Checkstatus();
    };
}

#endif // INSTANCEMANAGER_H_INCLUDED
