#ifndef TASKVIEWWIDGET_H_INCLUDED
#define TASKVIEWWIDGET_H_INCLUDED

#include <Wt/WApplication>
#include <Wt/WContainerWidget>
#include <Wt/WStandardItem>
#include <Wt/WStandardItemModel>
#include <Wt/WString>
#include <Wt/WTreeView>
#include <string>
#include <Wt/WText>
#include <deque>
#include "NotifyEvent.h"


namespace Wt
{
    class WStandardItem;
    class WStandardItemModel;
    class WTreeView;
    class WText;
    class WContainerWidget;
    class WApplication;
}
using namespace Wt;

class TaskViewWidget: public WTreeView
{
public:
    TaskViewWidget(WContainerWidget* parent = NULL);
    bool setTaskId(int nTaskId);
    void setupNotifyEventMethod(NotifyMethod notifyMethod, WObject* notifyObj);
    void clearModel();
private:
    static WStandardItem* checkedItem;
    WContainerWidget    * m_parent;
    WStandardItemModel  * m_model;
    WTreeView           * m_treeView;
    int                   m_taskId;
    int                   m_width;
    int                   m_height;

    NotifyMethod          m_notifyMethod;
    WObject*              m_notifyObj;

    void itemChanged(WStandardItem* item);
    bool createModel(int nTaskId);
};

#endif // TASKVIEWWIDGET_H_INCLUDED
